Subject: bug#20302: closed (Re: bug#20302: peek-char messes up file position on binary string ports)

From: [email-masked] (GNU bug Tracking System)
Date: Wed, 04 Nov 2015 21:14:02 +0000

Your bug report

#20302: peek-char messes up file position on binary string ports

which was filed against the guile package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
20302: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=20302
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#20302: peek-char messes up file position on binary string ports
From: Mark H Weaver <[email-masked]>
To: David Kastrup <[email-masked]>
Cc: [email-masked]
Date: Wed, 04 Nov 2015 16:12:38 -0500
List-Id: <debbugs-submit.debbugs.gnu.org>

Mark H Weaver <[email-masked]> writes:

> Mark H Weaver <[email-masked]> writes:
>
>> David Kastrup <[email-masked]> writes:
>>
>>> (use-modules (rnrs bytevectors) (rnrs io ports))
>>> (let ((port (open-bytevector-input-port
>>> 	     (string->utf8 "Blablabla\nBlablabla\n"))))
>>>   (seek port 13 SEEK_SET)
>>>   (format #t "~c ~d\n" (peek-char port)
>>> 	  (ftell port)))
>>> ;; Outputs b 3 but should output b 13
>>>
>>> This is using
>>> guile (GNU Guile) 2.0.11
>>> Packaged by Debian (2.0.11-deb+1-1)
>>
>> Ouch :-(
>>
>> The problem is that r6rs-ports.c:bip_seek assumes that
>> c_port->read_{buf,pos,end} point to the original bytevector, and fail to
>> handle the case where it points to a "putback" buffer.
>>
>> Note that (ftell port) is equivalent to (seek port 0 SEEK_CUR).
>
> I've attached a preliminary patch set to fix this bug and some others.

I believe this is now fixed on the stable-2.0 branch, commit
448eb30e3d9e998e97a5d51875f861c9f6c1101c.  I'm closing this bug now.

     Thanks,
       Mark

Subject: peek-char messes up file position on binary string ports
From: David Kastrup <[email-masked]>
To: [email-masked]
Date: Sat, 11 Apr 2015 13:48:14 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Any idea how to work around _this_ one?

(use-modules (rnrs bytevectors) (rnrs io ports))
(let ((port (open-bytevector-input-port
	     (string->utf8 "Blablabla\nBlablabla\n"))))
  (seek port 13 SEEK_SET)
  (format #t "~c ~d\n" (peek-char port)
	  (ftell port)))
;; Outputs b 3 but should output b 13

This is using
guile (GNU Guile) 2.0.11
Packaged by Debian (2.0.11-deb+1-1)

-- 
David Kastrup